; wireframe stuff
;-----------------------

makeDiv4Table
	ldx #0
md4	txa
	lsr @
	lsr @
	sta DIV4,x
	inx
	bne md4

	rts

makeAndTable
	ldx #$7F
mAT	lda #%11111100
	sta ANDTABLE,x
	dex
	lda #%11110011
	sta ANDTABLE,x
	dex
	lda #%11001111
	sta ANDTABLE,x
	dex
	lda #%00111111
	sta ANDTABLE,x
	dex
	bpl mAT

	rts

makeOraTable
	ldx #$7F
mOT	lda #%00000010
	sta ORATABLE,x
	dex
	lda #%00001000
	sta ORATABLE,x
	dex
	lda #%00100000
	sta ORATABLE,x
	dex
	lda #%10000000
	sta ORATABLE,x
	dex
	bpl mOT

	rts

;--- line drawing routine
wires
	lda y2
	cmp y1
	bcs noswp
	ldx y1
	stx y2
	sta y1
	txa
	ldx x1
	ldy x2
	stx x2
	sty x1
	sec
noswp	sbc y1
	sta dy
	lda y1
	sta bufor+1
	ldx #{inx}
	lda x2
	sbc x1
	bcs noneg
	eor #$FF
	adc #1
	ldx #{dex}
noneg	sta dx
	stx dx_dy_delta
	stx dy_dx_delta
	ldx x1
	cmp dy
	bcc dy_dx

dx_dy
	eor #$FF
	adc #0			;C
dx_dy_loop
	cpx x2
	beq dx_dy_end
	sta temp
	ldy div4,x
	lda (bufor),y
	and ANDTABLE,x
	ora ORATABLE,x
	sta (bufor),y
dx_dy_delta
	inx
	lda temp
	clc
	adc dy
	bcc dx_dy_loop
	inc bufor+1
	sbc dx
	bcc dx_dy_loop
dx_dy_end
	rts

dy_dx
	lda dy
	eor #$FF
	adc #1
dy_dx_loop
	ldy bufor+1
	cpy y2
	beq dy_dx_end
	sta temp
	ldy div4,x
	lda (bufor),y
	and ANDTABLE,x
	ora ORATABLE,x
	sta (bufor),y
	inc bufor+1
	lda dx
	clc
	adc temp
	bcc dy_dx_loop
dy_dx_delta
	inx
	sbc dy
	bcc dy_dx_loop
dy_dx_end
	rts
;-------
vertIdx	dta b(0)
lineIdx	dta b(0)
x	dta b(0)
y	dta b(0)
angle	dta b(0)
x1	dta b(0)
x2	dta b(0)
y1	dta b(0)
y2	dta b(0)
dx	dta b(0)
dy	dta b(0)
xcenter	dta b(SCREEN_WIDTH/2)
ycenter	dta b(SCREEN_HEIGHT/2+SCREEN_TOP)

;--- draw wired cube - precalculated rotations are stored in rottable
WiredCube
	ldx #0
	stx lineIdx
	stx vertIdx
rp	lda #0
	sta temp
	lda angle
	;*32
	asl @
	rol temp
	asl @
	rol temp
	asl @
	rol temp
	asl @
	rol temp
	asl @
	rol temp

	clc
	adc #<ROTTABLE
	sta pnt
	lda temp
	adc #>ROTTABLE
	sta pnt+1

	ldx lineIdx
	ldy Connections,x
	lda (pnt),y
	clc
	adc xcenter		;#SCREEN_WIDTH/2
	sta x1
	tya
	clc
	adc #8
	tay
	lda (pnt),y
	clc
	adc ycenter		;#SCREEN_HEIGHT/2+SCREEN_TOP
	sta y1
	inx
	ldy Connections,x
	lda (pnt),y
	clc
	adc xcenter		;#SCREEN_WIDTH/2
	sta x2
	tya
	clc
	adc #8
	tay
	lda (pnt),y
	clc
	adc ycenter		;#SCREEN_HEIGHT/2+SCREEN_TOP
	sta y2
	inx
	stx lineIdx

	jsr wires

	ldx lineIdx
_lnz	cpx #24
	beq d_end
	jmp rp
d_end
	rts

Connections
	dta b(0,1)
	dta b(1,2)
	dta b(2,3)
	dta b(3,0)

	dta b(4,5)
	dta b(5,6)
	dta b(6,7)
	dta b(7,4)

	dta b(0,4)
	dta b(1,5)

	dta b(3,7)
	dta b(2,6)