;also known as fill...
;----------------------
makeAndTables
	ldx #0
mATs	lda #%00000000
	sta ANDLEFT,x
	lda #%11111111
	sta ANDRIGHT,x
	inx
	lda #%11000000
	sta ANDLEFT,x
	lda #%00111111
	sta ANDRIGHT,x
	inx
	lda #%11110000
	sta ANDLEFT,x
	lda #%00001111
	sta ANDRIGHT,x
	inx
	lda #%11111100
	sta ANDLEFT,x
	lda #%00000011
	sta ANDRIGHT,x
	inx
	cpx #128
	bne mATs

	rts

makeColorTables			;invoke AFTER makeAndTables
	ldx #SCREEN_WIDTH-1

mCT	lda #$00
	sta COLORLEFT00,x
	sta COLORRIGHT00,x

	lda #%01010101
	and ANDRIGHT,x
	sta COLORLEFT01,x
	lda #%01010101
	and ANDLEFT,x
	sta COLORRIGHT01,x
	
	lda #%10101010
	and ANDRIGHT,x
	sta COLORLEFT10,x
	lda #%10101010
	and ANDLEFT,x
	sta COLORRIGHT10,x

	lda #%11111111
	and ANDRIGHT,x
	sta COLORLEFT11,x
	lda #%11111111
	and ANDLEFT,x
	sta COLORRIGHT11,x

	dex
	bpl mCT

	rts

makeKKolorTable			;invoke AFTER makeColorTabs
	ldy #3
mKKx	ldx #3
mKK	stx temp
	lda ANDLEFT,x
	ora ANDRIGHT,y
	tax
	eor #$FF
	sta temp+1
	and COLORLEFT00
	sta KKOLOR00,x
	lda temp+1
	and COLORLEFT01
	sta KKOLOR01,x
	lda temp+1
	and COLORLEFT10
	sta KKOLOR10,x
	lda temp+1
	and COLORLEFT11
	sta KKOLOR11,x
	ldx temp
	dex
	bpl mKK
	dey
	bpl mKKx

	rts

generateFillCode
	ldx #0
	ldy #0
gFC	txa
	sta FILLCODEAdr,y
	lda #{sta (bufor),y}
	sta FILLCODE,x
	inx
	lda #bufor
	sta FILLCODE,x
	inx
	lda #{iny}
	sta FILLCODE,x
	inx
	iny
	cpy #FILLCODE_FILLLENGTH
	bne gFC

	rts

;---------------------
x1Edge	dta b(0)
y1Edge	dta b(0)
x2Edge	dta b(0)
y2Edge	dta b(0)

CalcEdge					; modified bresenham - idea from prObe's 'glenches' 1kB intro
	lda y2Edge
	sec
nswp	sbc y1Edge
	sta dy
	ldx #{inx}
	lda x2Edge
	sbc x1Edge
	bcs nneg
	eor #$FF
	adc #1
	ldx #{dex}
nneg	sta dx
	stx dxdy_delta
	stx dydx_delta
	ldx x1Edge
	cmp dy
	bcc dydx

dxdy
	eor #$FF
	adc #0			;C
	ldy y1Edge
dxdy_loop
	cpy y2Edge
	beq dxdy_end
	sta temp
	txa
	sta (pnt),y
	lda temp
dxdy_delta
	inx
	adc dy
	bcc dxdy_delta
	iny
	sbc dx
	bcc dxdy_loop
dxdy_end
	rts

dydx
	lda dy
	eor #$FF
	adc #1
	ldy y1Edge
dydx_loop
	cpy y2Edge
	beq dydx_end
	sta temp
	txa
	sta (pnt),y
	iny
	lda dx
	adc temp
	bcc dydx_loop
dydx_delta
	inx
	sbc dy
	bcc dydx_loop
dydx_end
	rts

;---------------------
xl	dta b(0)

FillPoly
	cpy y3
	bne doIt
	rts
doIt
	sty bufor+1

	lda LEFTEDGE,y
	sta xl
	ldx RIGHTEDGE,y
	cpx xl
	bcs fc_noswp
	stx xl
	tax
	lda xl
fc_noswp
	tay
	lda DIV4,x
	cmp DIV4,y
	bne not_same_byte

	sta temp
	lda ANDRIGHT,x
	ora ANDLEFT,y
	tax
	ldy temp
	and (bufor),y
_cc	ora KKOLOR00,x
	sta (bufor),y

	ldy bufor+1
	iny

	jmp FillPoly

not_same_byte
	tay
	lda (bufor),y
	and ANDRIGHT,x
_cr	ora COLORRIGHT00,x
	sta (bufor),y

	ldx FILLCODEAdr,y
	lda #{rts}
	sta FILLCODE,x
	stx _fcres+1

	ldx xl
	ldy DIV4,x
	lda (bufor),y
	and ANDLEFT,x
_cl	ora COLORLEFT00,x
	sta (bufor),y

	iny
	lda FILLCODEAdr,y
	sta _fcjsr+1

_kk	lda #$00
_fcjsr	jsr FILLCODE
	lda #{sta (bufor),y}
_fcres	sta FILLCODE

	ldy bufor+1
	iny

	jmp FillPoly

;---------------------
triIdx	dta b(0)
x3	dta b(0)
y3	dta b(0)
polysQty	dta b(4*12)
chckV	dta b(0)

RotDaCube
	ldy #0
rdc	sty vertIdx
	lda #0
	sta temp
	lda angle
	;*32
	asl @
	rol temp
	asl @
	rol temp
	asl @
	rol temp
	asl @
	rol temp
	asl @
	rol temp

	clc
	adc #<ROTTABLE
	sta pnt
	lda temp
	adc #>ROTTABLE
	sta pnt+1

	ldy vertIdx
	;x
	lda (pnt),y
	clc
	adc xcenter
	sta RotatedX,y
	;y
	tya
	clc
	adc #8
	tay
	lda (pnt),y
	clc
	adc ycenter
	ldy vertIdx
	sta RotatedY,y
	;color
	tya
	clc
	adc #16
	tay
	lda (pnt),y
	ldy vertIdx
	sta VertColor,y
	iny

	cpy #8
	bne rdc

	rts

FeelDaCube
	ldy #0
dloop	sty triIdx

	ldx Triangles,y
	lda RotatedX,x
	sta x1				;$2e
	lda RotatedY,x
	sta y1				;$0d
	iny
	ldx Triangles,y
	lda RotatedX,x
	sta x2				;$2e
	lda RotatedY,x
	sta y2				;$31
	iny
	ldx Triangles,y
	lda RotatedX,x
	sta x3				;$52
	lda RotatedY,x
	sta y3				;$31
	iny
	ldx Triangles,y
	lda CCTAB,x
	sta _cc+2
	lda CRTAB,x
	sta _cr+2
	lda CLTAB,x
	sta _cl+2
	lda KKTAB,x
	sta _kk+1
	iny
	sty triIdx

	lda chckV
	beq visible
	jsr CheckVisibility
	bmi nextTri
visible
	jsr SortVerts

	lda #<LEFTEDGE
	sta pnt
	lda #>LEFTEDGE
	sta pnt+1

	;dx12
	lda x1				;$2e
	sta x1Edge
	lda x2				;$52
	sta x2Edge
	lda y1				;$0d
	sta y1Edge
	lda y2				;$31
	sta y2Edge

	jsr CalcEdge

	;dx23
	lda x2
	sta x1Edge
	lda x3
	sta x2Edge
	lda y2
	sta y1Edge
	lda y3
	sta y2Edge

	jsr CalcEdge

	lda #<RIGHTEDGE
	sta pnt
	lda #>RIGHTEDGE
	sta pnt+1

	;dx13
	lda x1
	sta x1Edge
	lda x3
	sta x2Edge
	lda y1
	sta y1Edge
	lda y3
	sta y2Edge

	jsr CalcEdge

	ldy y1
	jsr FillPoly
nextTri
	ldy triIdx
	cpy polysQty		;#4*12
	beq DrawEnd
	jmp dloop
DrawEnd
	rts

CheckVisibility
	sec
	lda x2
	sbc x3
	tax
	sec
	lda y2
	sbc y1
	jsr mul16
	sty temp
	sta temp+1

	sec
	lda x1
	sbc x2
	tax
	sec
	lda y3
	sbc y2
	jsr mul16

	sec
	tax
	tya
	sbc temp
	txa
	sbc temp+1

	rts

SortVerts
	lda y1
	ldy y2
	cmp y2
	bcc vs23
	sty y1
	sta y2
	tay
	lda x1
	ldx x2
	sta x2
	stx x1
	lda c1
	ldx c2
	sta c2
	stx c1

vs23	cpy y3
	bcc vs12
	lda y3
	sty y3
	sta y2
	ldy x2
	ldx x3
	sty x3
	stx x2
	ldy c2
	ldx c3
	sty c3
	stx c2

vs12	ldy y1
	cpy y2
	bcc sorted
	lda y2
	sta y1
	sty y2
	lda x2
	ldx x1
	sta x1
	stx x2
	lda c2
	ldx c1
	sta c1
	stx c2

sorted
	rts

CopyTriangles			;ax: src, y: bytes quantity
	sty temp
	stx pnt
	sta pnt+1

	ldy #0
cT	lda (pnt),y
	sta Triangles,y
	iny
	cpy temp
	bne cT

	rts

RotatedX
:16	dta b(0)

RotatedY
:16	dta b(0)

VertColor
:8	dta b(0)

TrianglesCube
	dta b(0,1,2)
	dta b(0)
	dta b(0,2,3)
	dta b(0)
	dta b(5,7,6)
	dta b(0)
	dta b(4,7,5)
	dta b(0)
	dta b(0,3,4)
	dta b(1)
	dta b(3,7,4)
	dta b(1)
	dta b(1,5,2)
	dta b(1)
	dta b(2,5,6)
	dta b(1)
	dta b(2,6,3)
	dta b(2)
	dta b(3,6,7)
	dta b(2)
	dta b(0,4,5)
	dta b(2)
	dta b(0,5,1)
	dta b(2)

Triangles
:18*4	dta b(0)

CCTAB	dta b(>KKOLOR00, >KKOLOR01, >KKOLOR10, >KKOLOR11)
CLTAB	dta b(>COLORLEFT00, >COLORLEFT01, >COLORLEFT10, >COLORLEFT11)
CRTAB	dta b(>COLORRIGHT00, >COLORRIGHT01, >COLORRIGHT10, >COLORRIGHT11)
KKTAB	dta b(%00000000, %01010101, %10101010, %11111111)