;mr gouraud
;-------------------
makeColorTex
	ldx #0
mCTx	txa
:4	lsr @
	sta COLORTEX,x
	inx
	cpx #64
	bne mCTx

	lda #$03
	ldx #38
dfd	sta COLORTEX,x
	inx
	cpx #64
	bne dfd

	rts

makeColorShiftTables
	ldx #SCREEN_WIDTH-1

mCST	lda #$00
	sta COLORSHIFT00,x

	lda #%00000001
	sta COLORSHIFT01,x

	lda #%00000010
	sta COLORSHIFT10,x

	lda #%00000011
	sta COLORSHIFT11,x

	dex

	lda #$00
	sta COLORSHIFT00,x

	lda #%00000100
	sta COLORSHIFT01,x

	lda #%00001000
	sta COLORSHIFT10,x

	lda #%00001100
	sta COLORSHIFT11,x

	dex

	lda #$00
	sta COLORSHIFT00,x

	lda #%00010000
	sta COLORSHIFT01,x

	lda #%00100000
	sta COLORSHIFT10,x

	lda #%00110000
	sta COLORSHIFT11,x

	dex

	lda #$00
	sta COLORSHIFT00,x

	lda #%01000000
	sta COLORSHIFT01,x

	lda #%10000000
	sta COLORSHIFT10,x

	lda #%11000000
	sta COLORSHIFT11,x

	dex
	bpl mCST

	rts

generateGrdCode
	lda #<GRDCODE
	sta pnt
	lda #>GRDCODE
	sta pnt+1

	ldx #HLINE

gGC	ldy #0

	lda pnt
_gL	sta GRDCODEAdrLSB
	lda pnt+1
_gH	sta GRDCODEAdrMSB

	ldy #0

	lda #{lda HLINE}
	sta (pnt),y
	iny
	txa
	sta (pnt),y
	iny
	inx
	lda #{ora HLINE}
	sta (pnt),y
	iny
	txa
	sta (pnt),y
	iny
	inx
	lda #{ora HLINE}
	sta (pnt),y
	iny
	txa
	sta (pnt),y
	iny
	inx
	lda #{ora HLINE}
	sta (pnt),y
	iny
	txa
	sta (pnt),y
	iny
	inx
	lda #{sta (bufor),y}
	sta (pnt),y
	iny
	lda #bufor
	sta (pnt),y
	iny
	lda #{iny}
	sta (pnt),y
	iny
	tya
	clc
	adc pnt
	sta pnt
	lda pnt+1
	adc #0
	sta pnt+1
	inc _gL+1
	inc _gH+1

	cpx #SCREEN_WIDTH+HLINE
	bne gGC

	rts

;---------------------
cl	dta b(0)
cr	dta b(0)
;xl	dta b(0)
xr	dta b(0)
dc	dta b(0)

CalcHLine
	lda xr
	sec
	sbc xl
	sta dx
	ldx #{inx}
	lda cr
	sbc cl
	bcs hnoneg
	eor #$FF
	adc #1
	ldx #{dex}
hnoneg	sta dc
	stx dc_dx_delta
	stx dx_dc_delta
	ldx cl
	cmp dx
	bcc dx_dc		;b if dx>dc

dc_dx
	eor #$FF
	adc #0			;C
	ldy xl
dc_dx_loop
	cpy xr
	beq dc_dx_end
	sta temp

	stx temp2		;
	lda COLORTEX,x		;
	tax			;

	lda CSHFTMSB,x		;get msb of the proper table (depending on color)

	ldx temp2		;

	sta _cs1+2
_cs1	lda COLORSHIFT00,y	;get properly shifted color
	sta HLINE,y
	lda temp
dc_dx_delta
	inx
	adc dx
	bcc dc_dx_delta
	iny
	sbc dc
	bcc dc_dx_loop
dc_dx_end
	rts

dx_dc
	lda dx
	eor #$FF
	adc #1
	ldy xl
dx_dc_loop
	cpy xr
	beq dx_dc_end
	sta temp

	stx temp2		;
	lda COLORTEX,x		;
	tax			;

	lda CSHFTMSB,x

	ldx temp2		;

	sta _cs2+2
_cs2	lda COLORSHIFT00,y
	sta HLINE,y
	iny
	lda dc
	adc temp
	bcc dx_dc_loop
dx_dc_delta
	inx
	sbc dx
	bcc dx_dc_loop
dx_dc_end
	rts

CSHFTMSB	dta b(>COLORSHIFT00, >COLORSHIFT01, >COLORSHIFT10, >COLORSHIFT11)

;---------------------
kolor	dta b(0)

GrdPolyEnd
	rts
	iny
GrdPoly
	cpy y3
	beq GrdPolyEnd
	sty bufor+1

	lda LEFTEDGECOLOR,y
	sta cl			;$03
	lda RIGHTEDGECOLOR,y
	sta cr			;$03

	lda LEFTEDGE,y
	sta xl			;$3f
	ldx RIGHTEDGE,y		;$38
	cpx xl
	beq GrdPoly-1
	bcs grd_noswap
	txa
	ldx cl
	ldy cr
	stx cr
	sty cl
	ldx xl
	sta xl
grd_noswap
	stx xr

	jsr CalcHLine

	ldx xr
	ldy xl
	lda DIV4,x
	cmp DIV4,y
	bne grd_not_same_byte

	sta temp
	txa
	sbc xl
	tax			;x:pixel counter
	lda HLINE,y
	dex
	beq byte_ok
	ora HLINE+1,y
	beq byte_ok
	ora HLINE+2,y
byte_ok	sta kolor
	ldx xr
	lda ANDLEFT,y
	ora ANDRIGHT,x
	ldy temp
	and (bufor),y
	ora kolor
	sta (bufor),y

	ldy bufor+1
	bne GrdPoly-1
	beq GrdPoly-1

grd_not_same_byte
	txa
	and #3
	tay			;y:pixel counter
	beq right_ok
	lda HLINE-1,x
	dey
	beq right_ok
	ora HLINE-2,x
	dey
	beq right_ok
	ora HLINE-3,x
right_ok
	sta kolor
	ldy DIV4,x
	lda (bufor),y
	and ANDRIGHT,x
	ora kolor
	sta (bufor),y

	ldx GRDCODEAdrLSB,y
	stx _grdres+1			;$84
	lda GRDCODEAdrMSB,y		;$92
	sta _grdres+2
	sta _grdrts+2
	lda #{rts}
_grdrts	sta GRDCODE,x		;GRDCODE must start from the beginning of the page!!!

	ldx xl
	txa
	and #%11111100
	clc
	adc #4
	sec
	sbc xl
	tay			;y:pixel counter
	lda HLINE,x
	inx
	dey
	beq left_ok
	ora HLINE,x
	inx
	dey
	beq left_ok
	ora HLINE,x
	inx
	dey
	beq left_ok
	ora HLINE,x
left_ok	sta kolor
	ldx xl
	lda ANDLEFT,x
	ldy div4,x
	lda (bufor),y
	and ANDLEFT,x
	ora kolor
	sta (bufor),y
	iny
	
	lda GRDCODEAdrLSB,y		;$21
	sta _grdjsr+1
	lda GRDCODEAdrMSB,y		;$92
	sta _grdjsr+2

_grdjsr	jsr GRDCODE

	lda #{lda HLINE}
_grdres	sta GRDCODE

	ldy bufor+1
	jmp GrdPoly-1

;-
c1	dta b(0)
c2	dta b(0)
c3	dta b(0)

DrawGrd
	ldy #0
grdloop	sty triIdx

	ldx Triangles,y
	lda RotatedX,x
	sta x1
	lda RotatedY,x
	sta y1
	lda VertColor,x
	sta c1
	iny
	ldx Triangles,y
	lda RotatedX,x
	sta x2
	lda RotatedY,x
	sta y2
	lda VertColor,x
	sta c2
	iny
	ldx Triangles,y
	lda RotatedX,x
	sta x3
	lda RotatedY,x
	sta y3
	lda VertColor,x
	sta c3
	iny
	sty triIdx

	jsr CheckVisibility
	bpl do_da_tri
	jmp nextGrdTri

do_da_tri
	jsr SortVerts

	;calc edges

	lda #<LEFTEDGE
	sta pnt
	lda #>LEFTEDGE
	sta pnt+1

	;dx12
	lda x1
	sta x1Edge
	lda x2
	sta x2Edge
	lda y1
	sta y1Edge
	lda y2
	sta y2Edge

	jsr CalcEdge

	;dx23
	lda x2
	sta x1Edge
	lda x3
	sta x2Edge
	lda y2
	sta y1Edge
	lda y3
	sta y2Edge

	jsr CalcEdge

	lda #<RIGHTEDGE
	sta pnt
	lda #>RIGHTEDGE
	sta pnt+1

	;dx13
	lda x1
	sta x1Edge
	lda x3
	sta x2Edge
	lda y1
	sta y1Edge
	lda y3
	sta y2Edge

	jsr CalcEdge

	;calc edges colors

	lda #<LEFTEDGECOLOR
	sta pnt
	lda #>LEFTEDGECOLOR
	sta pnt+1

	;dc12
	lda c1
	sta x1Edge
	lda c2
	sta x2Edge
	lda y1
	sta y1Edge
	lda y2
	sta y2Edge

	jsr CalcEdge

	;dc23
	lda c2
	sta x1Edge
	lda c3
	sta x2Edge
	lda y2
	sta y1Edge
	lda y3
	sta y2Edge

	jsr CalcEdge

	lda #<RIGHTEDGECOLOR
	sta pnt
	lda #>RIGHTEDGECOLOR
	sta pnt+1

	;dc13
	lda c1
	sta x1Edge
	lda c3
	sta x2Edge
	lda y1
	sta y1Edge
	lda y3
	sta y2Edge

	jsr CalcEdge

	ldy y1
	jsr GrdPoly
nextGrdTri
	ldy triIdx
	iny
	cpy polysQty
	beq GrdEnd
	jmp grdloop
GrdEnd
	rts
