;---------------------------- division routine
ACL	EQU $A0
ACH	EQU $A1
XTNDL	EQU $A2
XTNDH	EQU $A3
AUXL	EQU $A4
AUXH	EQU $A5
;----------------------------
DIVMON	LDY #16      	;INDEX FOR 16 BITS
hehe	ASL ACL      	;DIVIDEND/2, CLEAR QUOTIENT BIT
	ROL ACH
	ROL XTNDL
	ROL XTNDH
	SEC
	LDA XTNDL   	;TRY SUBTRACTING DIVISOR
	SBC AUXL
	TAX
	LDA XTNDH
	SBC AUXH
	BCC hihi       	;TOO SMALL, QBIT=0
	STX XTNDL    	;OKAY, STORE REMAINDER
	STA XTNDH
	INC ACL      	;SET QUOTIENT BIT = 1
hihi	DEY          	;NEXT STEP
	BNE hehe
	RTS
;----------------------------

;21240/(256+z),	z<-64,64>
zval	dta a(256-128)

makePerspectiveTab
	ldx #-128
mPT	stx temp
	lda #0
	sta xtndl
	sta xtndh

	lda #<21240
	sta acl
	lda #>21240
	sta ach

	lda zval
	sta auxl
	lda zval+1
	sta auxh

	jsr DIVMON


	lda acl
	ldx temp
	sta PERSPECTIVE,x

	clc
	lda zval
	adc #1
	sta zval
	lda zval+1
	adc #0
	sta zval+1

	inx
	cpx #128
	bne mPT

	rts
;----------------------------

makeTrigTabs
	ldx #0
	ldy #64
mc1
	lda SINUS,y
	sta COSINUS,x
	iny
	inx
	bne mc1

	rts
;----------------------------

makeSqrTab					; table used by multiplication routine
	ldx #0
	stx SQR1_L+$100
	stx SQR1_H+$100
	stx SQR2_L+$ff
	stx SQR2_H+$ff
	ldy #$ff
msqr	txa
	lsr @
	adc SQR1_L+$100,x
	sta SQR1_L,y
	sta SQR1_L+$101,x
	sta SQR2_L-1,y
	sta SQR2_L+$100,x
	lda #0
	adc SQR1_H+$100,x
	sta SQR1_H,y
	sta SQR1_H+$101,x
	sta SQR2_H-1,y
	sta SQR2_H+$100,x
	inx
	dey
	bne msqr

	rts
;----------------------------

mul8					; 8*8->8
	eor #$80
	sta h1+1
	eor #$ff
	sta h2+1
	txa
	eor #$80
	tax
	sec
h1	lda SQR1_H,x
h2	sbc SQR2_H,x

	rts

mul16	eor #$80		;8*8->16
	sta el1+1
	sta eh1+1
	eor #$ff
	sta el2+1
	sta eh2+1
	txa
	eor #$80
	tax
	sec
el1	lda SQR1_L,x
el2	sbc SQR2_L,x
	tay
eh1	lda SQR1_H,x
eh2	sbc SQR2_H,x

	rts