z	dta b(0)
xangle	dta b(0)
yangle	dta b(0)
zangle	dta b(0)
xn	dta b(0)
yn	dta b(0)
zn	dta b(0)

Rotate						; used for 3d chessboard rotation
	ldy #0
rot	sty vertIdx

	lda gridX,y
	sta x
	lda gridY,y
	sta y
	lda gridZ,y
	sta z

	jsr rotX
	jsr rotY
	jsr rotZ

	ldy zn
	ldx PERSPECTIVE,y
	lda yn
	jsr mul8
	clc
	adc ycenter
	ldy vertIdx
	sta RotatedY,y
	sta y

	ldy zn
	ldx PERSPECTIVE,y
	lda xn
	jsr mul8
	clc
	adc xcenter
	ldy vertIdx
	sta RotatedX,y
	sta x

	ldy vertIdx
	iny
	cpy #16
	bne rot

	rts

GridX	dta b(-54, -18, 18, 54)
	dta b(-54, -18, 18, 54)
	dta b(-54, -18, 18, 54)
	dta b(-54, -18, 18, 54)

GridZ	dta b(0, 0, 0, 0)
	dta b(0, 0, 0, 0)
	dta b(0, 0, 0, 0)
	dta b(0, 0, 0, 0)

GridY	dta b(-54, -54, -54, -54)
	dta b(-18, -18, -18, -18)
	dta b(18, 18, 18, 18)
	dta b(54, 54, 54, 54)

TrianglesChess
	dta b(0,1,4)
	dta b(0)
	dta b(1,4,5)
	dta b(0)
	dta b(1,2,5)
	dta b(3)
	dta b(2,5,6)
	dta b(3)
	dta b(2,3,6)
	dta b(0)
	dta b(3,6,7)
	dta b(0)
	dta b(4,5,8)
	dta b(3)
	dta b(5,8,9)
	dta b(3)
	dta b(5,6,9)
	dta b(0)
	dta b(6,9,$0A)
	dta b(0)
	dta b(6,7,$0A)
	dta b(3)
	dta b(7,$0A,$0B)
	dta b(3)
	dta b(8,9,$0C)
	dta b(0)
	dta b(9,$0C,$0D)
	dta b(0)
	dta b(9,$0A,$0D)
	dta b(3)
	dta b($0A,$0D,$0E)
	dta b(3)
	dta b($0A,$0B,$0E)
	dta b(0)
	dta b($0B,$0E,$0F)
	dta b(0)

;Xn = X
;Yn = Y*cos(a) - Z*sin(a)
;Zn = Y*sin(a) + Z*cos(a)

rotX
	;Xn = X
	lda x
	sta xn

	;Yn = Y*cos(a) - Z*sin(a)
	ldy xangle
	ldx SINUS,y
	lda z
	jsr mul16
	sty temp
	sta temp+1

	ldy xangle
	ldx COSINUS,y
	lda y
	jsr mul16
	tax
	tya
	sec
	sbc temp
	sta temp
	txa
	sbc temp+1
	and #%111111
:2	asl @
:6	lsr temp
	ora temp
	sta yn

	;Zn = Y*sin(a) + Z*cos(a)
	ldy xangle
	ldx SINUS,y
	lda y
	jsr mul16
	sty temp
	sta temp+1

	ldy xangle
	ldx COSINUS,y
	lda z
	jsr mul16
	tax
	tya
	clc
	adc temp
	sta temp
	txa
	adc temp+1
	and #%111111
:2	asl @
:6	lsr temp
	ora temp
	sta zn

	lda xn
	sta x
	lda yn
	sta y
	lda zn
	sta z

	rts

;Xn = X*cos(b) - Z*sin(b)
;Yn = Y
;Zn = X*sin(b) + Z*cos(b)

rotY
	;Xn = X*cos(b) - Z*sin(b)
	ldy yangle
	ldx SINUS,y
	lda z
	jsr mul16
	sty temp
	sta temp+1

	ldy yangle
	ldx COSINUS,y
	lda x
	jsr mul16
	tax
	tya
	sec
	sbc temp
	sta temp
	txa
	sbc temp+1
	and #%111111
:2	asl @
:6	lsr temp
	ora temp
	sta xn

	;Yn = Y
	lda y
	sta yn

	;Zn = X*sin(b) + Z*cos(b)
	ldy yangle
	ldx SINUS,y
	lda x
	jsr mul16
	sty temp
	sta temp+1

	ldy yangle
	ldx COSINUS,y
	lda z
	jsr mul16
	tax
	tya
	clc
	adc temp
	sta temp
	txa
	adc temp+1
	and #%111111
:2	asl @
:6	lsr temp
	ora temp
	sta zn

	lda xn
	sta x
	lda yn
	sta y
	lda zn
	sta z

	rts

;Xn = X*cos(c) - Y*sin(c)
;Yn = X*sin(c) + Y*cos(c)
;Zn = Z

rotZ
	;Xn = X*cos(c) - Y*sin(c)
	ldy zangle
	ldx SINUS,y
	lda y
	jsr mul16
	sty temp
	sta temp+1

	ldy zangle
	ldx COSINUS,y
	lda x
	jsr mul16
	tax
	tya
	sec
	sbc temp
	sta temp
	txa
	sbc temp+1
	and #%111111
:2	asl @
:6	lsr temp
	ora temp
	sta xn

	;Yn = X*sin(c) + Y*cos(c)
	ldy zangle
	ldx SINUS,y
	lda x
	jsr mul16
	sty temp
	sta temp+1

	ldy zangle
	ldx COSINUS,y
	lda y
	jsr mul16
	tax
	tya
	clc
	adc temp
	sta temp
	txa
	adc temp+1
	and #%111111
:2	asl @
:6	lsr temp
	ora temp
	sta yn

	;Zn = Z
	lda z
	sta zn

	lda xn
	sta x
	lda yn
	sta y
	lda zn
	sta z

	rts